package be.iminds.ilabt.jfed.highlevel.tasks;

import be.iminds.ilabt.jfed.highlevel.controller.Task;

import javax.annotation.Nonnull;
import java.util.HashMap;

/**
 * User: twalcari
 * Date: 6/16/2015
 * Time: 16:09
 */
public abstract class CacheableTaskFactory<S, T extends Task> {

    private final HashMap<S, T> cachedTasks = new HashMap<>();

    @Nonnull public synchronized T getTask(@Nonnull S input) {
        return cachedTasks.computeIfAbsent(input, this::createNewTask);
    }

    @Nonnull protected abstract T createNewTask(@Nonnull S input);


}
